#include <iostream>
#include <new>			//	NEW: new(nothrow)
#include <cassert>		//	NEW: assert()
#include "myvector.h"

using namespace std;

MyVector :: MyVector(const long long int n )		// Standard-, Parameterkonstruktor
    : length_( n>0 ? n : 0), val_(0)
{
    //
    //                        Restrict available memory in the shell  by:
    //				ulimit
    //
    cout << "--> " << length_ << endl;
    if ( length_>0 )
    {
//        val_    = new(nothrow) double [length_];  // no exception is thrown
        val_    = new double [length_];	     // throws "bad_alloc" in case of insufficient memory
//        assert(val_ != 0);
        cout << "##  " << val_ << endl;
    }
}

// ToDo: Add copy constructor
//       use constructor delegation
//MyVector :: MyVector(const MyVector& orig)
// : MyVector(orig.length_)
//  {
//      for (long long int i=0; i<length_; i++)
//        {
//            val_[i] = orig.val_[i];
//        }
//  }

MyVector :: ~MyVector()				// Destruktor
{
    delete [] val_;
}

// ToDo: Add assignment operator
//MyVector& MyVector :: operator=(const MyVector& orig)	// copy assignment
//{
//    if (this != &orig)
//    {
//        delete [] val_;
//        length_ = orig.length_;
//        if (length_>0)
//        {
//            val_ = new double [length_];
//            for (long long int i=0; i<length_; i++)
//            {
//                val_[i] = orig.val_[i];
//            }
//        }
//        else
//        {
//            val_ = 0;
//        }
//    }
//    return *this;
//}

ostream & operator<<(ostream & s, const MyVector& orig)
{
    long long int i;

    s << endl << "MyVector has " << orig.size() << " components" << endl;
    for (i=0; i<orig.size(); i++)
    {
        s << orig[i]<< "  ";
    }
    s << endl;

    return s;
}

